/***************************************************************************
 *   Copyright (C) 2003 by Thomas E. Bruno                                 *
 *   oss@vwords.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*  *********************************************************************
*	     This file contains functions that assist in   		*
*       System settings such as daemon mode, and 			*
*       command line parsing 						*
*									*
*									*
*********************************************************************** */



int daemonize(void)
{

    int pid;

    pid = fork();

    switch (pid) {

        case -1:
            printf("Fork Failed\n");
            exit(EXIT_FAILURE);
        case 0:
		/* setting session id */
          setsid();
          break;
        default:
		/* exiting parent to open up console */
           _exit(EXIT_SUCCESS);
                }

  return (EXIT_SUCCESS);
}



static int handle_cmdline(int argc, char *argv[])
{
int c;
int option_index = 0;
static struct option opts[] = {
                 {"debug",no_argument,0,'d'},
                 {"version",no_argument,0,'v'},
                 {"help",no_argument,0,'h'},
		 {0, 0, 0, 0}
                       };



    while((c = getopt_long( argc, argv, "dvh", opts, &option_index)) != -1)
    {
        switch (c)
            {
            case 0:
              /* If this option set a flag, do nothing else now. */
              if (opts[option_index].flag != 0)
                 break;
                 printf ("option %s", opts[option_index].name);
              if (optarg)
                printf (" with arg %s", optarg);
                printf ("\n");
                break;
            case 'd':
                debug_flag = TRUE;
                break;
            case 'v':
                printf("Poweracpid Version %s\n",POWERACPIDVERSION);
                exit(EXIT_SUCCESS);
                break;
            case 'h':
            default:
                help();
                break;
            }
        }


return (EXIT_SUCCESS);
}


read_config()
{

}


struct acpi_event_cmd read_event_file(int event_fileFD)
{
    char buffer[64];
    int i = 0;
    int space = 0;
    struct acpi_event_cmd finished_format;

    while(i < 64){
	read(event_fileFD,buffer+i,1);
            if(buffer[i] == '\n'){
               buffer[i] = '\0';
               break;
               }
            i++;
    }

  finished_format = event_cmd_format(buffer);


  return finished_format;

}


struct acpi_event_cmd event_cmd_format(char buf1[])
{

   int i=0;
   int i1 = 0;
   int i2 = 0;
   int i3 = 0;
   int spcount = 0;
   struct acpi_event_cmd event_cmd, *p;
   p = &event_cmd;

   while(i < 64)
   {
      if((buf1[i] != ' ') && spcount == 0) p->event[i] = buf1[i];
      else if(buf1[i] == ' ' && spcount == 0) { p->event[i] = '\0';
                                             ++spcount; }


      else if((buf1[i] != ' ') && spcount == 1) p->device[i1++] = buf1[i];
      else if(buf1[i] == ' ' && spcount == 1) { p->device[i1] = '\0';
                                            ++spcount; }

      else if((buf1[i] != ' ') && spcount == 2) p->id[i2++] = buf1[i];
      else if(buf1[i] == ' ' && spcount == 2) { p->id[i2] = '\0';
                                             ++spcount; }

      else if((buf1[i] != ' ' || buf1[i] != '\0') && spcount == 3) p->info[i3++] = buf1[i];
      else if((buf1[i] == ' ' || buf1[i] == '\0') && spcount == 3) { p->info[i3] = '\0';
                                             ++spcount;
                                             i = 0;
                                             break; }
      i++;
   }

   return event_cmd;
}


int
ud_create_socket(const char *name)
{
	struct sockaddr_un acpid_socket;
	int fd;
        int c; 					/* for error checking */
	int size;

        unlink(name);


        /* to create socket int socket (int namespace, int style, int protocol)  */
        fd = socket(AF_UNIX, SOCK_STREAM, 0);
	if (fd < 0 ) { return fd; }


	acpid_socket.sun_family = AF_UNIX;
	strncpy(acpid_socket.sun_path, name, sizeof (acpid_socket.sun_path));

 size = (offsetof (struct sockaddr_un, sun_path) + strlen (acpid_socket.sun_path) + 1);
	c = bind (fd, (struct sockaddr *) &acpid_socket, size);
	if( c < 0 ){ return c; }

        c = listen(fd, 10);
	if( c < 0) { return c; }




	return fd;

}

int ud_accept(int socket_FD)
{
   struct sockaddr_un *socket_accept_ST;
   int length = sizeof(struct sockaddr_un);
   int c;
   c = accept(socket_FD, (struct sockaddr *) &socket_accept_ST, &length);
   if (c < 0 ) { return c; }

   return (SUCCESS);

}


/*  Output for help */
void help(void){
printf("\n");
printf(" This is poweracpid %s.  Poweracpid is designed to take care\n",POWERACPIDVERSION);
printf(" of all you power management needs.  Few options currently exist. They are as\n");
printf(" follows:\n\n");
printf("\t-d\tused to turn debug on, (Non-daemonise)\n");
printf("\t-v\t output versin number\n");
printf("\t-h\tPrints this help message\n");
printf("\n\n");
exit(EXIT_SUCCESS);
}
